<template>
    <div class="builder" :class="classes">
        <component :is="blocksMap[defineLayout(block)]" v-for="(block, index) in blocks_" :key="index" v-bind="componentProperties(block)"></component>
    </div>
</template>

<script>
import loader from "@js/utils/load-page.js";
import popup from "@js/modules/popups.js";

import size from "lodash-es/size";
import first from "lodash-es/first";
import last from "lodash-es/last";

export default {
    props: {
        blocks: {
            type: Array, 
        },
        page: {     
            
        }
    },

    data() {
        return {
            blocksMap: {
                media: 'block-media',
                banner: 'banner',
                tarife: 'block-tarife',
                textimage: 'block-ti',
                events: 'block-event',
                advantages: 'block-advantage',
                feedback: 'block-feedbacks',
                cards_timeline: 'block-timeline',
                coaches: 'block-coach',
                callback: 'block-form-callback',
                blog: 'block-blog-posts-builder'
            },

            blocks_: null,
        }
    },

    computed: {
        classes: function(){
            let c = [];

            if (size(this.blocks_)) {
                let f = first(this.blocks_),
                    l = last(this.blocks_);

                if (typeof f.params != 'undefined' && typeof f.params.scheme != 'undefined') {
                    c.push(`builder--first-${f.params.scheme}`);
                }

                if (typeof l.params != 'undefined' && typeof l.params.scheme != 'undefined') {
                    c.push(`builder--last-${l.params.scheme}`);
                }
            }

            return c;
        }
    },

    methods: {
        defineLayout: function(block){
            switch (block.acf_fc_layout) {
                case 'cards':
                    if (block.content.type == 'media') {
                        return 'media';
                    }
                    if (block.content.type == 'timeline') {
                        return 'cards_timeline';
                    }
                    if (block.content.type == 'groups') {
                        return 'advantages';
                    }
                    break;
            
                default:
                    return block.acf_fc_layout;
                    break;
            }
        },
        componentProperties: function(currentComponent) {
            let currentName = this.defineLayout(currentComponent);

            switch (currentName) {
                // case 'banner':
                //     let {   
                //             banner : { date='', event='', img : { url : img = '' }, button, full=false, colorize=true },
                //             params : { scheme = 'light', header : { title ='Заголовок' } }
                //         } = currentComponent;
                    
                    
                //     return { 
                //         params: {
                //             date,
                //             event,
                //             title,
                //             scheme,
                //             button: {
                //                 text: button.button.title,
                //                 link: button.button.url,
                //                 color: button.color,
                //                 dots: button.dots 
                //             },
                //             img
                //         },
                //         full,
                //         colorize
                //     }
                //     break;

                default:
                    return currentComponent;
                    break;
            }
        }
    },

    created() {
        if (!this.blocks) {
            if (!this.page) {
                throw 'Page or Blocks should be specified';
            } else {
                loader(this.page).then(data => {
                    if (data.data.blocks) {
                        this.blocks_ = data.data.blocks;
                        this.$nextTick(() => {
                            popup.init();
                        })
                    } else {
                        throw 'No blocks was loaded via API';
                    }
                });
            }
        } else {
            this.blocks_ = this.blocks;
        }
    }
}
</script>
